#!/usr/bin/env python
# vim: set ai fo+=crqn fo-=t sw=4 nowrap : ## vim modeline
####
# listener -- accepts pings from hosts
# 
# This is the listener component of caelyx's beacon system. It accepts pings
# from "clients", and stores them for display by "whereami".
##
# CAUTION: This is internet-facing code; check all user input before you 
# use it; and please tell me if I've failed to.
##
# Author: Simon Brown (caelyx) <simon@caelyx.net>
# Copyright: 2005, Simon Brown
# Licence: BSD. Please let me know if you use this; beer readily accepted. :)
####

## CONSTANT DEFINITIONS ##
dataDir='/var/www/html/beacons/' # Make sure this directory exists, and is writable
interfaces=['en0', 'en1'] # you want to change this if you're not on osx
domains={ # You want to change these values to something useful.
    'example.com': 'work',
    'example.net': 'home', 
    'example.edu': 'uni' 
    }

import cgi
import re
import cgitb; cgitb.enable()
from time import asctime, gmtime, time

def main():
# forget not the header, lest ye crash
    print "Content-Type: text/html\n\n"
# get the fields out of the CGI script
    cgifields = cgi.FieldStorage(keep_blank_values=1)

# attempt to open the file in question
    hostname = defang(cgifields['host'].value)
    filename = '%s%s' %(dataDir, hostname)
    fp = open ( filename, 'w' )

# then, work out where we are
    location = whereami(cgifields)

# then, write out the information
    fp.write('%s was last seen at %s, at %s\n' % ( 
	hostname,
	location, 
	asctime(gmtime(time())) 
	))
    for x in interfaces:
	fp.write(x)
	if cgifields.has_key(x):
	    fp.write(' -- %s \n' % defang(cgifields[x].value) )
	else: 
	    fp.write(' -- \n')

# then, close and cleanup
    fp.write('\n')


def whereami(cgifields):
# Use the domain to work out where we're located
    hostdom = defang(cgifields['domain'].value)
    if domains.has_key(hostdom): 
	return domains[hostdom]

# Use if we still don't know where we are, use an IP lookup on the 
# client information in the headers. XXX TODO

# Then, go to the internal IP information XXX TODO

# Finally, give up and declare it unknown
    return 'domain'


def defang(astring): return re.sub('[<>/\\%\'"]', '', astring)


main()
